import { login, logout, getInfo } from '@/api/user'
import { resetRouter } from '@/router'

const getDefaultState = () => {
  return {
    token: '',
    id_card: '',
    role: ''
  }
}

const state = getDefaultState()

const mutations = {
  RESET_STATE: (state) => {
    state = getDefaultState()
  },
  SET_TOKEN: (state, token) => {
    state.token = token
  },
  SET_ID_CARD: (state, id_card) => {
    state.id_card = id_card;
  },
  SET_ROLE: (state, role) => {
    state.role = role
  }
}

const actions = {
  // user login
  login({ commit }, userInfo) {
    const { username, password } = userInfo
    return new Promise((resolve, reject) => {
      login({ user_num: username.trim(), password: password }).then(response => {
        commit('SET_TOKEN', response.token)
        commit('SET_ID_CARD', username)
        // 解码jwt 获得role
<<<<<<< HEAD
        // let payload = response.token.split('.')[1]
        // let data = JSON.parse(decodeURIComponent(escape(window.atob(payload))));
        // let role = data.role
        // commit('SET_ROLE', role)
=======
        let payload = response.token.split('.')[1]
        let data = JSON.parse(decodeURIComponent(escape(window.atob(payload))));
        let role = data.role
        commit('SET_ROLE', role)
>>>>>>> a025baf3ccfea2fef8bc69b80776e0c33d2153a5
        // 存储到本地 关闭页面后，自动登录的功能还在考虑
        // if (response.code == 0) {
        //   sessionStorage['zssr_token'] = response.token;
        // }
        resolve()
      }).catch(error => {
        reject(error)
      })
    })
  },

  // get user info
  // getInfo({ commit, state }) {
  //   return new Promise((resolve, reject) => {
  //     getInfo(state.token).then(response => {
  //       const { data } = response

  //       if (!data) {
  //         return reject('Verification failed, please Login again.')
  //       }

  //       const { name, avatar } = data

  //       commit('SET_NAME', name)
  //       commit('SET_AVATAR', avatar)
  //       resolve(data)
  //     }).catch(error => {
  //       reject(error)
  //     })
  //   })
  // },

  // user logout
  logout({ commit, state }) {
    return new Promise((resolve, reject) => {
      resetRouter();
      commit('RESET_STATE');
      resolve();
    })
  },

  // remove token
  resetToken({ commit }) {
    return new Promise(resolve => {
      removeToken() // must remove  token  first
      commit('RESET_STATE')
      resolve()
    })
  }
}

export default {
  namespaced: true,
  state,
  mutations,
  actions
}

